/***************************************************************************
                          krosseyedoc.cpp  -  description
                             -------------------
    begin                : Sun Jun 10 19:09:16 CEST 2001
    copyright            : (C) 2001 by Tersevs
    email                : tersevs@home.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "krosseyedoc.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <qmessagebox.h>
#include <qcolor.h>

#ifndef PI
#define PI 3.14159265
#endif							
static int
 myrand(int max)
{
	float f;
	unsigned long l;
	l = rand();
	f = (float) l;
	f /= (float) (RAND_MAX + 1.0);
	return ((int) (f * ((float) max + 1.0)));
}

KrosseyeDoc::KrosseyeDoc()
{
/*	In the beginning, God made the land... */

	modified = false;
	setWidth(640);
	setHeigth(480);
	antialias = 1;
	maxdepth = 140;
	mindepth = 110;
	invert_depth = true;
	goggle_left_color = qRgb(255, 0, 0);
	goggle_right_color = qRgb(0, 255, 0);
	update.make_all_clean();
	tolerance = 1;
	color_dilution = 0.0;
	color_scatter = 100;
	dotsize = 0;
	rotate_dots = false;
	black_is_trans = false;
	layer_avg_trans = (float) 0.50;
	layer_merging_method = LYMR_LATEST;
	mouse_function = MOUSE_NONE;
	mouse_brush_size = 10;
	mouse_brush_pow = 1;
	renderstate.setup(0, heigth * antialias);
	depthmap_drawing_mode = DEPD_NORMAL;
	nullzone_mode = NULM_BRIDGE;
	depthmap_smoothing = 0;
	horiz_orgin_perc = 50;
	vert_orgin_perc = 50;
	horiz_handle_centered = false;
	redraw_screen_often = true;
	StereogramImage = NULL;
	DepthmapImage = NULL;
	ColormapImage = NULL;
	PatternImage = NULL;
	NewLayerImage = NULL;
	OldLayerImage = NULL;

	// horiz_orgin = NULL;
	timer = new QTimer(this);
	connect(timer, SIGNAL(timeout()), this, SLOT(slotTick()));
	newDoc();
}

KrosseyeDoc::~KrosseyeDoc()
{
}

void
 KrosseyeDoc::newDoc()
{

	// render_stop ();
	timer->stop();
	horizorgin.newdoc(width, heigth);
	renderstate.newdoc(heigth * antialias);

	/*
	 *  if(horiz_orgin) { delete horiz_orgin; } horiz_orgin = new
	 * int [heigth]; if(!horiz_orgin) { printf("Out of memory!
	 * Exiting!\n"); exit(-1); }
	 */
	if (StereogramImage)

	{
		delete(StereogramImage);
	}
	StereogramImage = new QImage(width, heigth, 32);
	if (!StereogramImage)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (NewLayerImage)

	{
		delete(NewLayerImage);
	}
	NewLayerImage = new QImage(width * antialias, heigth * antialias, 32);
	if (!NewLayerImage)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (OldLayerImage)

	{
		delete(OldLayerImage);
	}
	OldLayerImage = new QImage(width * antialias, heigth * antialias, 32);
	if (!OldLayerImage)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (DepthmapImage)

	{
		delete(DepthmapImage);
	}
	DepthmapImage = new QImage(width, heigth, 32);
	if (!DepthmapImage)
	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (ColormapImage)

	{
		delete(ColormapImage);
	}
	ColormapImage = new QImage(width, heigth, 32);
	if (!ColormapImage)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (PatternImage)

	{
		delete(PatternImage);
	}
	PatternImage = new QImage(width, heigth, 32);
	if (!PatternImage)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	update.make_all_dirty();
	clearStereogram();
	clearDepthmap();
	UpdateStereogram();
}

bool KrosseyeDoc::isModified()
const
{
	return modified;
}

/** No descriptions */
bool KrosseyeDoc::loadDepthmap(const QString & str)
{
	QImage *img = new QImage(width, heigth, 32);
	if (!img)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (!img->load(str))
	{
	  QMessageBox::warning(0, "Krosseye", "Unable to load depthmap:\n\n" + str);
		return (false);
	}
	*img = (img->smoothScale(width, heigth));
	for (int x = 0; x < width; x++)

	{
		for (int y = 0; y < heigth; y++)

		{
			DepthmapImage->setPixel(x, y, img->pixel(x, y));
		}
	}
	delete img;
	update.make_all_dirty();
	UpdateStereogram();
	return true;

	/*
	 *  DepthmapImage->load (str); *DepthmapImage =
	 * (DepthmapImage->smoothScale (width, heigth));
	 * UpdateStereogram();
	 */
	return true;
}

/** No descriptions */
bool KrosseyeDoc::loadColormap(const QString & str)
{
	if (!ColormapImage->load(str))
	{
	  QMessageBox::warning(0, "Krosseye", "Unable to load colormap:\n\n" + str);
		return false;
	}
	*ColormapImage = (ColormapImage->smoothScale(width, heigth));
	update.make_all_dirty();
	UpdateStereogram();
	return true;
}

/** No descriptions */
bool KrosseyeDoc::loadPattern(const QString & str)
{
	if (!PatternImage->load(str))
	{
	  QMessageBox::warning(0, "Krosseye", "Unable to load pattern:\n\n" + str);
		return false;
	}
	UpdateStereogram();
	return true;
}

/** No descriptions */
bool KrosseyeDoc::loadStereogram(const QString & str)
{
	QImage *img = new QImage(width, heigth, 32);
	if (!img)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (!img->load(str))
	{
	  QMessageBox::warning(0, "Krosseye", "Unable to load dstereogram:\n\n" + str);
	}
	*img = (img->smoothScale(width * antialias, heigth * antialias));
	for (int x = 0; x < width * antialias; x++)

	{
		for (int y = 0; y < heigth * antialias; y++)

		{
			NewLayerImage->setPixel(x, y, img->pixel(x, y));
		}
	}
	delete img;
	update.make_all_dirty();
	UpdateStereogram();
	return true;
}

/** No descriptions */
bool KrosseyeDoc::saveStereogram(const QString & str)
{
	QString s;
	s = str.lower();
	if (s.find(".png") < 0)

	{
		s.append(".png");
	}
	StereogramImage->save(s, "PNG");
	return true;
}

/** No descriptions */
bool KrosseyeDoc::saveDepthmap(const QString & str)
{
	QString s;
	s = str.lower();
	if (s.find(".png") < 0)

	{
		s.append(".png");
	}
	DepthmapImage->save(s, "PNG");
	return true;
}

/** No descriptions */
float
 KrosseyeDoc::GetDepth(int x, int y)
{
	float depth, rawdepth;
	int xmin, xmax;
	xmin = x - depthmap_smoothing;
	if (xmin < 0)
		xmin = 0;
	xmax = x + depthmap_smoothing;
	if (xmax > (width - 1))
		xmax = width - 1;
	if (xmax < xmin)
		xmax = xmin;
	rawdepth = 0.0;
	for (x = xmin; x <= xmax; x++)

	{
		rawdepth += (float) GetRawDepth(x, y);
	}
	rawdepth /= (1.0 + xmax - xmin);
	if (invert_depth)
		rawdepth = 255.0 - rawdepth;
	depth =
		(int) (antialias *
			   ((((maxdepth - mindepth) * rawdepth) / 255.0) + mindepth));
	return (depth);
}
int
 KrosseyeDoc::ScatterX(int x)
{
	int used_scatter;
	int xscatter;
	int xpos = -1;

	if(current_method == REND_RANDOMCOLORS)
		used_scatter = 100;
	else
		used_scatter = color_scatter;

	xscatter = (used_scatter * width) / 100;

	while (xpos < 0 || xpos >= width)

	{
		xpos = x - xscatter + myrand(2 * xscatter);
	}
	return (xpos);
}

/** No descriptions */
QRgb KrosseyeDoc::GetColor(int x, int y)
{
	if (y < 0)
		y = 0;
	if (y >= heigth)
		y = heigth - 1;
	return (ColormapImage->pixel(ScatterX(x), y));
}

/** Render a row of dots */
bool
KrosseyeDoc::render_dot(int *depth, uint * color, int *filled,
		   int xstart, int y, bool allow_incomplete_rows,
		   int mark)
{
	int xlast;
	int xmid;
	int z, x;
	int red, green, blue;
	int rotation = 0;
	bool drawn_dot_at_xstart = false;
	int error_for_optimum_x;
	int optimum_x;
	int op;
	float used_dilution;
	if (rotate_dots)
		rotation = myrand(360);
	if (xstart < 0)
		xstart = 0;
	if (xstart > (width * antialias - 1))
		xstart = width * antialias - 1;
	if (current_method == REND_GOGGLES)

	{
		if (xstart <= 1 || xstart >= (antialias * width - 1))
			return (false);
		if (abs(depth[xstart - 1] - depth[xstart + 1]) > 2)
			return (false);
		op = myrand(255);
		QRgb rgb1 = goggle_left_color.rgb();
		QRgb rgb2 = goggle_right_color.rgb();
		if (invert_depth)

		{
			DrawDot(xstart - depth[xstart] / 2, y, rgb1);
			DrawDot(xstart + depth[xstart] / 2, y, rgb2);
		}

		else
		{
			DrawDot(xstart + depth[xstart] / 2, y, rgb1);
			DrawDot(xstart - depth[xstart] / 2, y, rgb2);
		}
		return true;
	}
	for (int phase = 0; phase <= 3; phase++)

	{
		int xstop;
		int xdelta;
		bool draw_phase;
		switch (phase)

		{
			case 0:			/* Check if dot can be drawn to the left */
				xstop = -1;
				xdelta = -1;
				draw_phase = false;
				break;
			case 1:			/* Check if dot can be drawn to the right */
				xstop = width * antialias;
				xdelta = +1;
				draw_phase = false;
				break;
			case 2:			/* Drawn to the left */
				xstop = -1;
				xdelta = -1;
				draw_phase = true;
				break;
			case 3:			/* Draw to the right */
				xstop = width * antialias;
				xdelta = +1;
				draw_phase = true;
				break;
		}

		/*
		 * Set up data for this pass
		 */
		xlast = xstart;
		optimum_x = xstart;
		error_for_optimum_x = 1000000;
		red = qRed(color[xstart]);
		green = qGreen(color[xstart]);
		blue = qBlue(color[xstart]);

		/*
		 * Do the pass
		 */
		for (x = xstart; x != xstop; x += xdelta)

		{
			int error_here;
			xmid = (x + xlast) / 2;
			z = abs(xlast - x);
			error_here = abs(z - depth[xmid]);

			/*
			 * Find minimum
			 */
			if (error_here <= error_for_optimum_x)

			{
				error_for_optimum_x = error_here;
				optimum_x = x;
			}
			if ((z > (maxdepth * antialias)) || (error_for_optimum_x == 0))

			{

				/*
				 * Minimum has been passed or reached!
				 */
				if (error_for_optimum_x > tolerance)

				{

					/*
					 * the error at optimum is just too big
					 */
					if (allow_incomplete_rows)
						continue;

					else
						return (false);
				}

				else
				{

					/*
					 * the optimum is acceptable
					 */
					xlast = optimum_x;
					x = optimum_x;
					error_for_optimum_x = 1000000;
					if (allow_incomplete_rows && filled[x])

					{
						continue;
					}

					if(current_method == REND_RANDOMCOLORS)
						used_dilution = 0;
					else
						used_dilution = color_dilution;


					red =
						(int) (red * (1.0 - used_dilution)) +
						(int) (qRed(color[optimum_x]) * (used_dilution));
					green =
						(int) (green * (1.0 - used_dilution)) +
						(int) (qGreen(color[optimum_x]) * (used_dilution));
					blue =
						(int) (blue * (1.0 - used_dilution)) +
						(int) (qBlue(color[optimum_x]) * (used_dilution));

					if (!drawn_dot_at_xstart)

					{
						if (allow_incomplete_rows)

						{
							filled[xstart] = mark;
							DrawDot(xstart, y, color[xstart], rotation);
							drawn_dot_at_xstart = true;
						}
					}
					if (draw_phase || allow_incomplete_rows)

					{
						DrawDot(optimum_x, y, qRgb(red, green, blue), rotation);
						filled[optimum_x] = mark;
					}
				}
			}
		}
	}

	/*
	 * pass 0-4 done
	 */
	if (!drawn_dot_at_xstart)

	{
		DrawDot(xstart, y, color[xstart], rotation);
	}
	filled[xstart] = mark;
	return (true);
}
void
 KrosseyeDoc::Prepare_row_data(int y, int *depth, int *filled,
							   unsigned int *color)
{
	int x;
	for (x = 0; x < antialias * width; x++)

	{
		depth[x] = (int) (GetDepth(x / antialias, y / antialias));
		filled[x] = 0;
		switch (current_method)

		{
			case REND_RANDOMCOLORS:
				color[x] = qRgb(myrand(255), myrand(255), myrand(255));
				break;
			case REND_COLORMAPPED:
			case REND_SCATTERED_DOTS:
			case REND_PUNCHED:
				color[x] = GetColor(x / antialias, y / antialias);
				break;
			default:
				color[x] = qRgb(128, 128, 128);
				break;
		}
	}
}
void
 KrosseyeDoc::render_by_mouseclick(int x, int y, int x2, int y2)
{
	int *depth;
	unsigned int *color;
	int *filled;
	x *= antialias;
	y *= antialias;
	x2 *= antialias;
	y2 *= antialias;
	if (isRendering())
		return;
	if (current_method == REND_PATTERNMAPPED)

	{
		if (y == y2)
			renderstate.setup(y - 10, y + 10);
		if (y < y2)
			renderstate.setup(y, y2);

		else
			renderstate.setup(y2, y);
		renderer_start();
	}

	else
	{
		depth = new int[antialias * width];
		filled = new int[antialias * width];
		color = new unsigned int[antialias * width];
		Prepare_row_data(y, depth, filled, color);
		render_dot(depth, color, filled, x, y, false);

		// UpdateStereogram();
	}
}

/** No descriptions */
bool KrosseyeDoc::renderer_tick(void)
{
	int
	 y;
	int
	 prnheigth;

	// y=renderstate.ycurrent;
	if (!renderstate.IsRendering())

	{
		return false;
	}
	y = renderstate.GetLine();
	switch (current_method)

	{
		case REND_PATTERNDOTTED:
			prnheigth = PatternImage->height();
			if (prnheigth > mindepth)
				prnheigth = mindepth;
			renderstate.StepLine(prnheigth);

			// ycurrent += prnheigth;
			break;
		case REND_COLORMAPPED:
		case REND_RANDOMCOLORS:
			renderstate.StepLine(myrand(dotsize-1)+1);

			// ycurrent+=2*dotsize-1;
			break;
		case REND_SCATTERED_DOTS:
		case REND_PUNCHED:
			renderstate.StepLine(2 * dotsize - 1);

			// ycurrent+=2*dotsize;
			break;
		default:
			renderstate.StepLine(1);

			// ycurrent++;
			break;
	}
	signalPercentDone(renderstate.GetPercentDone());
	if (renderstate.TimeToRefreshScreen())

	{
		if (redraw_screen_often)
			UpdateStereogram();
	}
	
	render_row(y);
	
	if (renderstate.RenderingLastLine())

	{
		renderer_stop();
		return true;
	}
	return (false);
}


#define MIN_PATT_RERENDER_LEN 9

/** No descriptions */
bool KrosseyeDoc::render_row(int y)
{

	// bool *filled_pixels;
	float scalex, scaley;



	int
	 horiz_period;
	int
	 horiz_orgin;
	int
	 istart;
	int
	 istop;
	int
	 left, right;
	int
	 patternpixel_x;
	int
	 patternpixel_y;
	int
	 patternwidth =
	PatternImage->
	width();
	int
	 patternheigth =
	PatternImage->
	height();
	int *
	 depth;
	unsigned int *
	 color;
	int *
	 filled;
	int
	 old_tolerance;
	bool old_black_is_trans;
	int
	 i, j;
	int
	 horiz_handle, vert_offset;
	int
	 x;
	QRgb col = qRgb(0, 0, 0);
	depth = new int[antialias * width];
	filled = new int[antialias * width];
	color = new unsigned int[antialias * width];

	/*
	 * Prepare data for row to render
	 */
	Prepare_row_data(y, depth, filled, color);

	/*
	 * Render the dots on the line
	 */
	switch (current_method)

	{
		case REND_RANDOMCOLORS:
		case REND_COLORMAPPED:

/*** Render a screen line ***/

			/*
			 * Lay the foundation...
			 */
			for (x = 0; x < antialias * width; x++)
			{
				if(viewdebug)
					DrawDot(x, y, qRgb(255,0,0));
				else
					DrawDot(x, y, color[myrand(antialias*width-1)]);
			}

			/*
			 * Render all possible incomplete and complete lines
			 */

			for (i = 0; i < 2*antialias * width; i++)
			{
				x = myrand(antialias * width);
				if(filled[x])
					continue;
				render_dot(depth, color, filled, x, y, true);
			}

			/* The 'second foundation' is completed. Go for real! */

			for (x = 0; x < antialias * width; x++)
				filled[x]=0;
	
			for (i = 0; i < 2*antialias * width; i++)
			{
				x = myrand(antialias * width);
				if(filled[x])
					continue;
				render_dot(depth, color, filled, x, y, false);
			}

			for (x = 0; x < antialias * width; x++)
			{
				if(filled[x])
					continue;
				render_dot(depth, color, filled, x, y, false);
			}
			break;

		case REND_PATTERNMAPPED:
			horiz_orgin = horizorgin.get(y / antialias) * antialias;

			/*
			 * Find a good row
			 */
			for (j = 0; j < antialias * width; j++)
				color[j] = 0;
			old_black_is_trans = black_is_trans;
			old_tolerance = tolerance;
			tolerance = 100000;
			black_is_trans = true;
			render_dot(depth, color, filled, horiz_orgin, y, false);
			tolerance = old_tolerance;
			black_is_trans = old_black_is_trans;

			/*
			 * Locate two dots
			 */
			if (1)

			{
				istart = horiz_orgin;
				istop = -1;
				for (i = 1; i < width * antialias; i++)

				{
					x = horiz_orgin + i;
					if (x < width * antialias)

					{
						if (filled[x])

						{
							istop = x;
							break;
						}
					}
				}
			}
			if (istop == -1)

			{
				istop = horiz_orgin;
				istart = -1;
				for (i = 1; i < width * antialias; i++)

				{
					x = horiz_orgin - i;
					if (x < width * antialias)

					{
						if (filled[x])

						{
							istart = x;
							break;
						}
					}
				}
			}

			/*
			 * Got the markers!
			 */
			horiz_period = istop - istart;	// + 1;

			vert_offset = (patternheigth * (150 - vert_orgin_perc)) / 100;
			scalex = (float) patternwidth;
			scalex /= (float) horiz_period;
			scaley = (float) patternwidth;
			scaley /= (float) maxdepth;
			scaley /= antialias;

			/*
			 * Remove markers...
			 */

			for (x = 0; x < width * antialias; x++)
			{
				filled[x] = false;
			}

			/*
			 * Render image between good markers!
			 */

			for (i = istart; i < istop + 1; i++)
			{
				if (horiz_handle_centered)

				{
					horiz_handle = horiz_period / 2;
				}

				else
				{
					horiz_handle = 0;
				}

				patternpixel_x =
					(int) ((((i - istart) + horiz_handle) % horiz_period) * scalex);
				patternpixel_y = (int) (((y) * scaley) + vert_offset) % patternheigth;
				col = PatternImage->pixel(patternpixel_x, patternpixel_y);
				for (j = 0; j < antialias * width; j++)
				{
					color[j] = col;
				}
				if (i <= 0)
					i = 0;

				render_dot(depth, color, filled, i, y, true, patternpixel_x + 1);
			}


			/* Fill all single missing pixels */

			for (x = 1; x < (width * antialias - 1); x++)
			{
				if (filled[x - 1] && !filled[x] && filled[x + 1])
				{
					if (x < horiz_orgin)
					{
						filled[x] = filled[x + 1];
						DrawPixel(x, y, PatternImage->pixel(filled[x] - 1, patternpixel_y));
					}
					else
					{
						filled[x] = filled[x + 1];
						DrawPixel(x, y, PatternImage->pixel(filled[x] - 1, patternpixel_y));
					}
				}
			}

			/* Find all single present pixels (we want continous regions ) */

			if (nullzone_mode != NULM_BRIDGE)
			{
				for (x = 1; x < (width * antialias - 1); x++)
				{
					if (!filled[x - 1] && filled[x] && !filled[x + 1])
					{
						filled[x] = 0;
					}
				}
			}

			for (left = 0; left < antialias * width; left++)
			{
				int rightmark = 0, leftmark = 0;

				if (!filled[left])

				{
					for (right = left + 1; right < antialias * width; right++)
					{
						if (filled[right])
							break;
					}
					if (left > 0)
						leftmark = filled[left - 1];
					if (right < antialias * width)
						rightmark = filled[right];
					if (leftmark == 0 && rightmark != 0)
						leftmark = rightmark;
					if (leftmark != 0 && rightmark == 0)
						rightmark = leftmark;

					if (!leftmark && !rightmark)
					{
						leftmark = 1;
						rightmark = 1;
					}

					int patternwidth = PatternImage->width();

					if (leftmark > rightmark)
					{
						rightmark += patternwidth;
					}
					for (x = left; x < right; x++)
					{
						int bridgestyle;

						if ((right - left <= MIN_PATT_RERENDER_LEN * antialias) || (nullzone_mode == NULM_BRIDGE))
						{
							QRgb col;


							/*
							 * Only bridge short gaps
							 */


							/* Use hardbridges if we've skipped */
							if (3 * (rightmark - leftmark) > patternwidth)
							{
								/* HARDBRIDGE */
								if (horiz_orgin < x)
									filled[x] = leftmark;
								else
									filled[x] = rightmark;

								bridgestyle = 1;
							}
							else
							{
								/* SOFTBRIDGE */
								filled[x] = leftmark + (rightmark - leftmark) * (x - left) / (right - left);

								bridgestyle = 2;
							}

							filled[x]--;
							filled[x] %= patternwidth;
							filled[x]++;

							col = PatternImage->pixel(filled[x] - 1, patternpixel_y);

							if (viewdebug)
							{
								if (x % 2)
								{
									if (bridgestyle == 1)
										col = qRgb(255, 0, 0);
									else
										col = qRgb(255, 255, 0);
								}
							}

							DrawDot(x, y, col);

						}
						else
						{
							if(nullzone_mode == NULM_IGNORE) /* Dont overlap */
								break;

							/* THIS_IS_BEST_FOR_INVERTED_ONLY
							bool from_left= true;
							
							if(x>horiz_orgin)
								from_left = !from_left;
							*/

							bool from_left= false;
							
							if(invert_depth)
								from_left = !from_left;

							if(x>horiz_orgin)
								from_left = !from_left;



							if(nullzone_mode == NULM_OL_MIRRORED)							
							{				
								if (from_left)
									filled[x] = (int) (leftmark - (x - (left - 1)) * scalex + 5*patternwidth + 1 + 0.5);
								else
									filled[x] = (int) (rightmark + (right - x) * scalex + 5*patternwidth + 1 + 0.5);

							}
							else
							{
								if (from_left)
									filled[x] = (int) (leftmark + (x - (left - 1)) * scalex + 5*patternwidth + 1 + 0.5);
								else
									filled[x] = (int) (rightmark - (right - x) * scalex + 5*patternwidth + 1 + 0.5);

							}

							if(nullzone_mode == NULM_OL_FAR)
								filled[x]+=patternwidth/3;
							

							filled[x]--;
							filled[x] %= patternwidth;
							filled[x]++;

							QRgb col = PatternImage->pixel(filled[x] - 1, patternpixel_y);

							if (viewdebug)
							{
								if (x % 2)
									col = qRgb(0, 255, 0);
							}

							for (j = 0; j < width * antialias; j++)
							{
								//if (x % 2)
								// col = qRgb(255, 0, 0);

								color[j] = col;
							}


							render_dot(depth, color, filled, x, y, true, filled[x]);

						}
					}
					left = right - 1;
				}
			}
			break;

		case REND_GOGGLES:
			render_dot(depth, color, filled, myrand(width * antialias), y, false);
			for (x = 0; x < (5 - dotsize) * (antialias * width / 640); x++)

			{
				render_dot(depth, color, filled, myrand(width * antialias), y,
						   false);
			}
			break;
		case REND_SCATTERED_DOTS:
		case REND_PUNCHED:
		case REND_PATTERNDOTTED:
		default:
			render_dot(depth, color, filled, myrand(width * antialias), y, false);
			break;
	}
	delete depth;
	delete filled;
	delete color;

	// delete filled_pixels;
	return true;
}
void
 KrosseyeDoc::setRenderMethod(enum rendmeth new_method)
{
	current_method = new_method;
}
void
 KrosseyeDoc::render_by_buttonpress(void)
{
	int y;
	for (y = 0; y < heigth; y++)

	{
		horizorgin.set(y, width * horiz_orgin_perc / 100 - 1);
	}

	// horiz_orgin= ((width*antialias) * horiz_orgin_perc)/100;
	renderstate.setup(0, antialias * heigth - 1);
	renderer_start();
}
void
 KrosseyeDoc::renderer_start(void)
{
	int prnheigth;

	/*
	 * Start the timer
	 */
	timer->start(0, FALSE);
	renderstate.start();
	switch (current_method)

	{
		case REND_PATTERNDOTTED:
			prnheigth = PatternImage->height();
			if (prnheigth > mindepth)
				prnheigth = mindepth;
			renderstate.StepLine(myrand(prnheigth));
			break;
		case REND_SCATTERED_DOTS:
		case REND_PUNCHED:
			renderstate.StepLine(myrand(dotsize * 2));
			break;
		default:

			// ycurrent = first_row_to_render;
			break;
	}
}
void
 KrosseyeDoc::renderer_stop(void)
{

	/*
	 * Start the timer
	 */
	timer->stop();

	// ycurrent = -1;
	renderstate.stop();
	signalPercentDone(100);
	UpdateStereogram();
}
bool KrosseyeDoc::isRendering(void)
{
	return (renderstate.IsRendering());

	/*
	 * if (ycurrent >= 0) return true;  return false;
	 */
}

/** No descriptions */
void
 KrosseyeDoc::slotTick()
{
	renderer_tick();
}
void
 KrosseyeDoc::DrawPixel(int x, int y, QRgb col)
{
	col &= RGB_MASK;
	if (black_is_trans && (col == 0))

	{
		return;
	}
	if (x >= 0 && x < (antialias * width - 1) && y >= 0
		&& y < (antialias * heigth - 1))

	{

		/*
		 * if(current_method == REND_PATTERNMAPPED) { QRgb oldcol,
		 * newcol; newcol = col; oldcol =
		 * StereogramImage->pixel(x,y); col =
		 * qRgb((int)(qRed(oldcol)*t+qRed(newcol)*(1-t)),
		 * (int)(qGreen(oldcol)*t+qGreen(newcol)*(1-t)),
		 * (int)(qBlue(oldcol)*t+qBlue(newcol)*(1-t)));  }
		 */
		if (current_method == REND_GOGGLES)
			col |= NewLayerImage->pixel(x, y);

		if (current_method == REND_PUNCHED)
			col = ColormapImage->pixel(x/antialias, y/antialias);

		NewLayerImage->setPixel(x, y, col);

/*** Mark line for redrawing ***/
		update.make_dirty(x, y);
	}
}

/** No descriptions */
void
 KrosseyeDoc::DrawDot(int cx, int cy, QRgb col, int rotation)
{
	int dx, dy;

	switch (current_method)

	{
		case REND_PATTERNDOTTED:

			{
				int prnwidth = PatternImage->width();
				int prnheigth = PatternImage->height();

				/*
				 * If uses doesnt know whats the deal is
				 */
				if (prnheigth > mindepth)
					prnheigth = mindepth;
				if (prnwidth > mindepth)
					prnwidth = mindepth;
				prnwidth *= antialias;
				prnheigth *= antialias;

				// Ugly... Should use some bitBlt thingie..
				for (float xp = -prnwidth / 2.0; xp < prnwidth / 2.0; xp += 0.5)

				{
					for (float yp = -prnheigth / 2.0; yp < prnheigth / 2.0; yp += 0.5)

					{
						int x, y;
						if (rotation)

						{
							float ax, ay, a1;
							a1 = 2.0 * PI * rotation / 360.0 + PI / 2.0;

							/*
							 * rotate!
							 */
							ax = sin(a1) * xp + cos(a1) * yp;
							ay = sin(a1) * yp - cos(a1) * xp;
							x = (int) (cx + ax);
							y = (int) (cy + ay);
							DrawPixel(x, y, PatternImage->pixel((int)
																((xp +
														prnwidth / 2.0) /
															  antialias),
															 (int) ((yp +
																prnheigth
																   / 2.0)
														  / antialias)));

							/*
							 * DrawPixel (x+1,y, PatternImage->pixel (
							 * (xp+prnwidth/2)/antialias,
							 * (yp+prnheigth/2)/antialias)); DrawPixel
							 * (x-1,y, PatternImage->pixel (
							 * (xp+prnwidth/2)/antialias,
							 * (yp+prnheigth/2)/antialias)); DrawPixel
							 * (x,y+1, PatternImage->pixel (
							 * (xp+prnwidth/2)/antialias,
							 * (yp+prnheigth/2)/antialias)); DrawPixel
							 * (x,y-1, PatternImage->pixel (
							 * (xp+prnwidth/2)/antialias,
							 * (yp+prnheigth/2)/antialias));
							 */
						}

						else
						{
							x = (int) (cx + xp);
							y = (int) (cy + yp);
							DrawPixel(x, y, PatternImage->pixel((int)
																((xp +
														prnwidth / 2.0) /
															  antialias),
															 (int) ((yp +
																prnheigth
																   / 2.0)
														  / antialias)));
						}
					}
				}
			}
			break;
		case REND_PATTERNMAPPED:
			DrawPixel(cx, cy, col);
			break;

		case REND_RANDOMCOLORS:
		case REND_COLORMAPPED:
			if(dotsize<=1)
			{
				DrawPixel(cx,cy,col);
			}
			else
			{
				for (dy = -(dotsize+1)/2; dy <= (dotsize)/2; dy++)
					for (dx = -(dotsize+1)/2; dx <= (dotsize)/2; dx++)
						DrawPixel(cx+dx,cy+dy,col);

			}
			break;

		default:
			if (dotsize <= 1)

			{
				DrawPixel(cx, cy, col);
			}

			else
			{
				int x, y;
				int ax;
				for (dy = -dotsize; dy < dotsize; dy++)

				{
					ax = (int) sqrt(dotsize * dotsize - dy * dy);
					for (dx = -ax; dx < ax; dx++)

					{
						x = cx + dx;
						y = cy + dy;
						DrawPixel(x, y, col);
					}
				}
			}
			break;
	}

	// printf("Drawdot(%d, %d)\n",x,y);
	//
	/*
	 * DrawPixel (x, y, col); if (dotsize > 0) { DrawPixel (x + 1,
	 * y, col); DrawPixel (x - 1, y, col); DrawPixel (x, y + 1,
	 * col); DrawPixel (x, y - 1, col);  } if (dotsize > 1) {
	 * DrawPixel (x + 1, y + 1, col); DrawPixel (x - 1, y - 1, col);
	 * DrawPixel (x - 1, y + 1, col); DrawPixel (x + 1, y - 1, col);
	 * }
	 */
}

/** No descriptions */
void
 KrosseyeDoc::clearStereogram()
{
	int x, y;
	if (!(OldLayerImage && NewLayerImage))
		return;
	for (x = 0; x < antialias * width; x++)

	{
		for (y = 0; y < antialias * heigth; y++)

		{
			NewLayerImage->setPixel(x, y, 0);
			OldLayerImage->setPixel(x, y, 0);
		}
	}
	update.make_all_dirty();
	UpdateStereogram();
}

/** No descriptions */
void
 KrosseyeDoc::clearDepthmap()
{
	int x, y;
	enum depdmode old = depthmap_drawing_mode;
	depthmap_drawing_mode = DEPD_NORMAL;
	for (x = 0; x < width; x++)

	{
		for (y = 0; y < heigth; y++)

		{
			SetRawDepth(x, y, 0);
		}
	}
	depthmap_drawing_mode = old;
	update.make_all_dirty();
	UpdateStereogram();
}
void
 KrosseyeDoc::CopyCurrentLayer()
{
	if (!(OldLayerImage && NewLayerImage))
		return;
	for (int x = 0; x < antialias * width; x++)

	{
		for (int y = 0; y < antialias * heigth; y++)

		{
			OldLayerImage->setPixel(x, y, NewLayerImage->pixel(x, y));
		}
	}
	update.make_all_dirty();
	UpdateStereogram();
}
void
 KrosseyeDoc::CopyLockedLayer()
{
	if (!(OldLayerImage && NewLayerImage))
		return;
	for (int x = 0; x < width * antialias; x++)

	{
		for (int y = 0; y < heigth * antialias; y++)

		{
			NewLayerImage->setPixel(x, y, OldLayerImage->pixel(x, y));
		}
	}
	update.make_all_dirty();
	UpdateStereogram();
}
void
 KrosseyeDoc::AcceptLayer()
{
	QImage *img = new QImage(width * antialias, heigth * antialias, 32);

	/*
	 * First save the old layer
	 */
	update.make_all_dirty();
	UpdateStereogram();
	*img =
		StereogramImage->smoothScale(width * antialias, heigth * antialias);
	if (!(OldLayerImage && NewLayerImage))
		return;
	for (int x = 0; x < width * antialias; x++)

	{
		for (int y = 0; y < heigth * antialias; y++)

		{
			OldLayerImage->setPixel(x, y, img->pixel(x, y));
		}
	}
	delete img;

	/*
	 * Now when the new layer is saved, we can clean it up...r
	 */
	RejectLayer();
}
void
 KrosseyeDoc::RejectLayer()
{
	for (int x = 0; x < width * antialias; x++)

	{
		for (int y = 0; y < heigth * antialias; y++)

		{
			NewLayerImage->setPixel(x, y, 0);
		}
	}
	update.make_all_dirty();
	UpdateStereogram();
}
void
 KrosseyeDoc::SwapLayer()
{
	if (OldLayerImage && NewLayerImage)

	{
		for (int x = 0; x < width * antialias; x++)

		{
			for (int y = 0; y < heigth * antialias; y++)

			{
				QRgb oldcol, newcol;
				oldcol = OldLayerImage->pixel(x, y);
				newcol = NewLayerImage->pixel(x, y);
				OldLayerImage->setPixel(x, y, newcol);
				NewLayerImage->setPixel(x, y, oldcol);
			}
		}
	}
	update.make_all_dirty();
	UpdateStereogram();
}
static int
 max(int a, int b)
{
	if (a > b)
		return (a);
	return (b);
}
void
 KrosseyeDoc::ForceDocumentChanged()
{
	emit documentChanged();
}
void
 KrosseyeDoc::UpdateStereogram()
{

	// QImage *img= new QImage(width*antialias, heigth*antialias,
	// 32);
	//
	/*
	 * Completly dirty - update all
	 */
	if (update.startline == -2)

	{
		update.startline = 0;
		update.startrow = 0;
		update.stopline = heigth * antialias - 1;
		update.stoprow = width * antialias - 1;
	}

	/*
	 * Completly clean - update nothing
	 */
	if (update.startline == -1)

	{
		emit documentChanged();
		update.make_all_clean();
		return;
	}
	if (OldLayerImage && NewLayerImage && StereogramImage)

	{
		for (int xb = update.startrow / antialias;
			 xb < update.stoprow / antialias; xb++)

		{
			for (int yb = update.startline / antialias;
				 yb < 1 + update.stopline / antialias; yb++)

			{
				int red = 0;
				int blue = 0;
				int green = 0;
				for (int xa = 0; xa < antialias; xa++)

				{
					for (int ya = 0; ya < antialias; ya++)

					{
						int x = xb * antialias + xa;
						int y = yb * antialias + ya;
						QRgb oldcol, newcol, col;
						oldcol = OldLayerImage->pixel(x, y);
						newcol = NewLayerImage->pixel(x, y);
						switch (layer_merging_method)

						{
							case LYMR_BRIGHTEST:
								col =
									qRgb(max(qRed(oldcol), qRed(newcol)),
									 max(qGreen(oldcol), qGreen(newcol)),
									  max(qBlue(oldcol), qBlue(newcol)));
								break;
							case LYMR_LATEST:
								if (qGray(newcol))
									col = newcol;

								else
									col = oldcol;
								break;
							case LYMR_TRANS:
								if (!qGray(newcol))

								{
									col = oldcol;
									break;
								}

								/*
								 * break intentionally left out
								 */
							case LYMR_AVERAGE:
								col = qRgb((int)
										(layer_avg_trans * qRed(oldcol) +
								   (1 - layer_avg_trans) * qRed(newcol)),
								(int) (layer_avg_trans * qGreen(oldcol) +
									   (1 -
									  layer_avg_trans) * qGreen(newcol)),
								 (int) (layer_avg_trans * qBlue(oldcol) +
										(1 -
									  layer_avg_trans) * qBlue(newcol)));
								break;
						}
						red += qRed(col);
						green += qGreen(col);
						blue += qBlue(col);
					}
				}
				red /= antialias * antialias;
				green /= antialias * antialias;
				blue /= antialias * antialias;
				StereogramImage->setPixel(xb, yb, qRgb(red, green, blue));
			}
		}
	}

	// *StereogramImage = img->smoothScale(width,heigth);
	// delete img;
	emit documentChanged();
	update.make_all_clean();
}
int
 KrosseyeDoc::GetRawDepth(int x, int y)
{
	if (x < 0 || x >= width || y < 0 || y >= heigth)
		return (0);
	return (qGray(DepthmapImage->pixel(x, y)));
}
void
 KrosseyeDoc::SetRawDepth(int x, int y, int depth)
{
	int olddepth;
	if (x < 0 || x >= width || y < 0 || y >= heigth)
		return;
	if (depth < 0)
		depth = 0;
	if (depth > 255)
		depth = 255;
	olddepth = GetRawDepth(x, y);
	switch (depthmap_drawing_mode)

	{
		case DEPD_NORMAL:
			break;
		case DEPD_RAISE:
			if (olddepth > depth)
				return;
			break;
		case DEPD_LOWER:
			if (olddepth < depth)
				return;
			break;

			/*
			 *  case DEPD_CUTABOVE: if(olddepth<depth) depth=olddepth;
			 *  break;
			 */
		case DEPD_CUTBELOW:
			if (olddepth < depth)
				depth = 0;

			else
				depth = olddepth;
			break;
	}
	if (depth > 255)
		depth = 255;
	if (depth < 0)
		depth = 0;
	DepthmapImage->setPixel(x, y, qRgb(depth, depth, depth));
}
void
 KrosseyeDoc::raise_depthmap_by_mouseclick(int cx, int cy)
{
	int x, y;
	int dx, dy, ax;
	for (dy = -mouse_brush_size; dy <= mouse_brush_size; dy++)

	{
		ax = (int) sqrt(mouse_brush_size * mouse_brush_size - dy * dy);
		for (dx = -ax; dx <= ax; dx++)

		{
			x = cx + dx;
			y = cy + dy;
			if (x < 0 || x >= width || y < 0 || y >= heigth)
				continue;
			SetRawDepth(x, y, GetRawDepth(x, y) + mouse_brush_pow);
		}
	}
}
void
 KrosseyeDoc::lower_depthmap_by_mouseclick(int cx, int cy)
{
	int x, y;
	int dx, dy, ax;
	for (dy = -mouse_brush_size; dy < mouse_brush_size; dy++)

	{
		ax = (int) sqrt(mouse_brush_size * mouse_brush_size - dy * dy);
		for (dx = -ax; dx < ax; dx++)

		{
			x = cx + dx;
			y = cy + dy;
			if (x < 0 || x >= width || y < 0 || y >= heigth)
				continue;
			SetRawDepth(x, y, GetRawDepth(x, y) - mouse_brush_pow);
		}
	}
}
void
 KrosseyeDoc::spread_depthmap_by_mouseclick(int cx, int cy)
{
	int x, y;
	int dx, dy, ax;
	int val = GetRawDepth(cx, cy);
	for (dy = -mouse_brush_size; dy <= mouse_brush_size; dy++)

	{
		ax = (int) sqrt(mouse_brush_size * mouse_brush_size - dy * dy);
		for (dx = -ax; dx <= ax; dx++)

		{
			x = cx + dx;
			y = cy + dy;
			if (x < 0 || x >= width || y < 0 || y >= heigth)
				continue;
			SetRawDepth(x, y, val);
		}
	}

	// soften_depthmap_by_mouseclick(cx,cy, 7);
}
void
 KrosseyeDoc::bridge1_depthmap_by_mouseclick(int x1, int y1, int x2, int y2)
{
	drawDepthmap_line(x1, y1, GetRawDepth(x1, y1), x2, y2,
					  GetRawDepth(x2, y2), mouse_brush_size,
					  mouse_brush_pow);
}
void
 KrosseyeDoc::bridge2_depthmap_by_mouseclick(int x1, int y1, int x2, int y2)
{
	enum depdmode old_depdmode = depthmap_drawing_mode;
	if (mouse_brush_pow < 100)

	{
		depthmap_drawing_mode = DEPD_RAISE;
	}
	drawDepthmap_flatline(x1, y1, GetRawDepth(x1, y1), x2, y2,
						  GetRawDepth(x2, y2), mouse_brush_size);
	depthmap_drawing_mode = old_depdmode;
}
void
 KrosseyeDoc::dot_depthmap_by_mouseclick(int x1, int y1)
{
	int z;
	z = (255 * mouse_brush_pow) / 100;
	if (z <= 2)
		z = 0;
	if (z >= 252)
		z = 255;
	drawDepthmap_dot(x1, y1, z, mouse_brush_size);
}
int
 KrosseyeDoc::calc_rawdm_area_avg(int cx, int cy, int area)
{
	int dx, dy, x, y, ax;
	int acc, num;
	if (area == 0)

	{

		/*
		 * Fast, lean and mean!
		 */
		acc = 4 * GetRawDepth(cx, cy);
		acc += GetRawDepth(cx - 1, cy);
		acc += GetRawDepth(cx + 1, cy);
		acc += GetRawDepth(cx, cy + 1);
		acc += GetRawDepth(cx, cy - 1);
		return ((acc + 4) / 8);
	}
	acc = GetRawDepth(cx, cy);
	num = 1;
	for (dy = -area; dy <= area; dy++)

	{
		ax = (int) sqrt(area * area - dy * dy);
		for (dx = -ax; dx <= ax; dx++)

		{
			x = cx - dx;
			y = cy + dy;
			if (x < 0 || x >= width || y < 0 || y >= heigth)
				continue;
			acc += GetRawDepth(x, y);
			num++;
		}
	}
	return (acc / num);
}
void
 KrosseyeDoc::drawDepthmap_dot(int cx, int cy, int z, int size, int arg)
{
	for (int dy = -size; dy <= size; dy++)

	{
		int ax = (int) sqrt(size * size - dy * dy);
		for (int dx = -ax; dx <= ax; dx++)

		{
			int x = dx + cx;
			int y = dy + cy;
			if (x < 0 || x >= width || y < 0 || y >= heigth)
				continue;
			SetRawDepth(x, y, z);
		}
	}
}
void
 KrosseyeDoc::drawDepthmap_raise(int cx, int cy, int size, int dist,
								 int pow)
{
	for (int dy = -size; dy <= size; dy++)

	{
		int ax = (int) sqrt(size * size - dy * dy);
		for (int dx = -ax; dx <= ax; dx++)

		{
			int x = dx + cx;
			int y = dy + cy;
			if (x < 0 || x >= width || y < 0 || y >= heigth)
				continue;
			if (GetRawDepth(x, y))

			{
				SetRawDepth(x, y,
							GetRawDepth(x,
								   y) + (GetRawDepth(x, y) * pow / 100));
				SetRawDepth(x, y, GetRawDepth(x, y) + dist);
			}
		}
	}
}
void
 KrosseyeDoc::drawDepthmap_flatline(int ax, int ay, int az, int bx, int by,
									int bz, int size)
{
	if ((ax == bx) && (ay == by))
		return;
	if (size < 0)
		return;
	float ab =
	sqrtf((float) ((ax - bx) * (ax - bx) + (ay - by) * (ay - by)));
	float dx = (bx - ax) / ab;
	float dy = (by - ay) / ab;
	float dz = (bz - az) / ab;
	float i;
	for (i = 0.0; i < ab; i += 1.0)

	{
		float x = ax + dx * i;
		float y = ay + dy * i;
		float z = az + dz * i;
		drawDepthmap_dot((int) x, (int) y, (int) z, (int) size);
	}
}
void
 KrosseyeDoc::drawDepthmap_line(int ax, int ay, int az, int bx, int by,
								int bz, int size, int pow)
{
	float a, i;
	if (ax == bx)

	{
		a = 0.0;
	}

	else
	{
		a = atan(((float) by - (float) ay) / ((float) bx - (float) ax));
		a -= (float) (PI / 2.0);
	}
	for (i = (float) -size; i < (float) size; i += (float) 0.9)

	{
		drawDepthmap_flatline((int) (ax + i * cos(a)),
							  (int) (ay + i * sin(a)),
							  (int) (az +
								  (pow / 100.0) * size * cos((i / size) *
															 (PI / 2.0))),
							  (int) (bx + i * cos(a)),
							  (int) (by + i * sin(a)),
							  (int) (bz +
									 (pow / 100.0) * size *
									 cos((i / size) * (PI / 2.0))), 1);
	}
}
void
 KrosseyeDoc::drawDepthmap_soften(int cx, int cy, int size, int pow)
{
	int x, y;
	int dx, dy, ax;
	int *buffer, index;
	if (pow < 0)
		pow = mouse_brush_pow;
	buffer = new int[(2 * size) * (2 * size)];
	index = 0;
	if (!buffer)
		return;
	for (int iteration = 0; iteration < pow; iteration++)

	{
		for (int phase = 0; phase < 2; phase++)

		{
			index = 0;
			for (dy = -size; dy <= size; dy++)

			{
				ax = (int) sqrt(size * size - dy * dy);
				for (dx = -ax; dx <= ax; dx++)

				{
					x = cx + dx;
					y = cy + dy;
					if (x < 0 || x >= width || y < 0 || y >= heigth)
						continue;
					if (phase == 0)
						buffer[index++] = calc_rawdm_area_avg(x, y, 0	/* size*pow/100
																		 */ );

					else
						SetRawDepth(x, y, buffer[index++]);
				}
			}
		}
	}
	delete buffer;
}
void
 KrosseyeDoc::drawDepthmap_triangle(int ax, int ay, int az, int bx, int by,
									int bz, int cx, int cy, int cz)
{
	if ((ax == bx) && (ay == by))
		return;
	float ab =
	sqrtf((float) ((ax - bx) * (ax - bx) + (ay - by) * (ay - by)));
	float dx = (bx - ax) / ab;
	float dy = (by - ay) / ab;
	float dz = (bz - az) / ab;
	float i;
	for (i = 0.0; i < ab; i += 1.0)

	{
		float x = ax + dx * i;
		float y = ay + dy * i;
		float z = az + dz * i;
		drawDepthmap_line((int) x, (int) y, (int) z, cx, cy, cz, 1, 0);
	}
}
void
 KrosseyeDoc::drawDepthmap_cone(int cx, int cy, int cz, int pow, int size)
{
	for (int i = 0; i < size; i++)

	{
		drawDepthmap_dot(cx, cy, cz + (int) ((pow / 100.0) * i), size - i);
	}
}
void
 KrosseyeDoc::drawDepthmap_sphere(int cx, int cy, int cz, int w, int h,
								  int pow, int arg)
{
	if (h <= 0 || w <= 0)
		return;
	float a1 = (2.0 * PI * arg) / 360.0 + PI / 2.0;
	for (float a = 0; a < 2 * PI; a += (float) 0.01)

	{
		float rx = w * cos(a);
		float ry = h * sin(a);
		float r = sqrt(rx * rx + ry * ry);
		for (float b = 0; b < 1.0; b += 1.0 / r)

		{
			float dx = b * rx;
			float dy = b * ry;
			float dz =
			(pow / 100.0) * sqrt((float) w * w +
								 (float) h * h) * sqrt(cos(b * (PI / 2)));
			int x = (int) (sin(a1) * dx + cos(a1) * dy) + cx;
			int y = (int) (sin(a1) * dy - cos(a1) * dx) + cy;
			drawDepthmap_dot(x, y, (int) (cz + dz), 2);
		}
	}
}
void
 KrosseyeDoc::drawDepthmap_disc(int cx, int cy, int cz, int rad, int arg1,
								int arg2)
{

	// float rad= sqrt(rx*rx+ry*ry+rz*rz);
	// float arg1,arg2;
	if (arg2 > 90 || arg2 < 0)
		return;
	float len = 2 * rad * PI;
	float da = (2 * PI) / len;
	for (float a = 0; a < 2 * PI; a += da)

	{
		float ax, ay, az, a1, a2, r1, r2, fx, fy;
		a1 = arg1 * 2.0 * PI / 360.0;
		a2 = arg2 * 2.0 * PI / 360.0;

		/*
		 * Min and max rad
		 */
		r1 = rad * cos(a2);
		r2 = rad;
		fx = r1 * cos(a);
		fy = r2 * sin(a);

		/*
		 * rotate!
		 */
		ax = sin(a1) * fx + cos(a1) * fy;
		ay = sin(a1) * fy - cos(a1) * fx;
		az = rad * sin(a2) * cos(a);
		drawDepthmap_line(cx, cy, cz, (int) (ax + cx), (int) (ay + cy),
						  (int) (az + cz), 1, 0);
	}
}
void
 KrosseyeDoc::drawDepthmap_copy(int sx, int sy, int sw, int sh, int dx,
								int dy, int argx, int argy, int argz)
{
	int d;
	int *buffer_x, *buffer_y, *buffer_z, buffer_index;
	buffer_x = new int[sw * sh * 5];
	buffer_y = new int[sw * sh * 5];
	buffer_z = new int[sw * sh * 5];
	buffer_index = 0;
	if (!(buffer_x && buffer_y && buffer_z))
		return;
	float az = (2.0 * PI * argz) / 360.0;
	float ax = (2.0 * PI * argx) / 360.0;
	float ay = (2.0 * PI * argy) / 360.0;
	for (float x = -sw / 2.0; x < sw / 2.0; x += 0.5)

	{
		for (float y = -sh / 2.0; y < sh / 2.0; y += 0.5)

		{
			d = GetRawDepth((int) (sx + x), (int) (sy + y));

			/*
			 * Z-rotation
			 */
			float ex = (cos(az) * x + sin(az) * y);
			float ey = (cos(az) * y - sin(az) * x);
			if (d)

			{

				/*
				 * x-rotation
				 */
				// ex = ex * cos(ax);
				d += (int) (ex * sin(ax));

				/*
				 * y-rotation
				 */
				// ey = ey * cos(ay);
				d += (int) (ey * sin(ay));
			}
			buffer_x[buffer_index] = (int) (dx + ex);
			buffer_y[buffer_index] = (int) (dy + ey);
			buffer_z[buffer_index] = d;
			buffer_index++;
		}
	}
	for (int i = 0; i < buffer_index; i++)

	{
		SetRawDepth(buffer_x[i], buffer_y[i], buffer_z[i]);
	}
	delete buffer_x;
	delete buffer_y;
	delete buffer_z;
}
void
 KrosseyeDoc::soften_depthmap_by_mouseclick(int cx, int cy, int pow)
{
	drawDepthmap_soften(cx, cy, mouse_brush_size, pow);
}
void
 KrosseyeDoc::drawDepthmap_load(const QString & str, int cx, int cy, int cz,
								int sizex, int sizey, int arg)
{
	QRgb col;
	int gry;
	QImage *img = new QImage(sizex, sizey, 32);
	float az = (2.0 * PI * arg) / 360.0;
	if (!img)

	{
		printf("Out of memory! Exiting!\n");
		exit(-1);
	}
	if (!img->load(str))
	{
	  QMessageBox::warning(0, "Krosseye", "Unable to load depthmap:\n\n" + str);
		return;
	}
	*img = (img->smoothScale(sizex, sizey));
	for (float x = 0.0; x < (float) sizex; x += 0.5)

	{
		for (float y = 0.0; y < (float) sizey; y += 0.5)

		{
			col = img->pixel((int) x, (int) y);
			gry = qGray(col) + cz;

			/*
			 * Do the rotation
			 */
			float ax = x - sizex / 2;
			float ay = y - sizey / 2;
			float bx = (cos(az) * ax + sin(az) * ay);
			float by = (cos(az) * ay - sin(az) * ax);
			SetRawDepth((int) (cx + bx), (int) (cy + by), gry);
		}
	}
	delete img;
}
int
 KrosseyeDoc::getWidth(void)
{
	return (width);
}
int
 KrosseyeDoc::getHeigth(void)
{
	return (heigth);
}
void
 KrosseyeDoc::setWidth(int w)
{
	width = w;
}
void
 KrosseyeDoc::setHeigth(int h)
{
	heigth = h;
}

/*** UPDATE CLASS METHODS ***/
void
 KrosseyeDoc::update_class::make_all_clean(void)
{
	startline = -1;
	stopline = -1;
}
void
 KrosseyeDoc::update_class::make_all_dirty(void)
{
	startline = -2;
	stopline = -2;
}
void
 KrosseyeDoc::update_class::make_dirty(int x, int y)
{
	if ((startline < 0) || (y < startline))
		startline = y;
	if ((stopline < 0) || (y > stopline))
		stopline = y;
	if ((startrow < 0) || (x < startrow))
		startline = x;
	if ((stoprow < 0) || (x > stoprow))
		stoprow = x;
}

/*** HORIZ ORGIN CLASS METHODS ***/
KrosseyeDoc:: hotizorg_class::hotizorg_class()
{
	horiz_orgin = NULL;
}

KrosseyeDoc:: hotizorg_class::~hotizorg_class()
{
	if (horiz_orgin)
		delete(horiz_orgin);
}
void
 KrosseyeDoc::hotizorg_class::newdoc(int w, int h)
{
	if (horiz_orgin)
		delete(horiz_orgin);
	horiz_orgin = new int[h];
	heigth = h;
	width = w;
}
int
 KrosseyeDoc::hotizorg_class::get(int y)
{
	int
	 o;
	if (y < 0)
		y = 0;
	if (y >= heigth)
		y = heigth - 1;
	if (!horiz_orgin)
		return (0);
	o = horiz_orgin[y];
	if (o < 0 || o > width - 1)
		o = 0;
	return (o);
}
void
 KrosseyeDoc::hotizorg_class::set(int y, int o)
{
	if (y < 0)
		y = 0;
	if (y >= heigth)
		y = heigth - 1;
	if (!horiz_orgin)
		return;
	horiz_orgin[y] = o;
}

/*** RENDERSTATE CLASS METHODS ***/
void
 KrosseyeDoc::renderstate_class::newdoc(int h)
{
	aheigth = h;
}
void
 KrosseyeDoc::renderstate_class::setup(int startline, int stopline)
{
	first_row_to_render = startline;
	last_row_to_render = stopline;
	if (first_row_to_render < 0)
		first_row_to_render = 0;
	if (last_row_to_render >= aheigth)
		last_row_to_render = aheigth - 1;
	update_counter = 0;
	ycurrent = -1;
}
void
 KrosseyeDoc::renderstate_class::start(void)
{
	ycurrent = first_row_to_render;
	update_counter;
}
void
 KrosseyeDoc::renderstate_class::stop(void)
{
	ycurrent = -1;
}
bool KrosseyeDoc::renderstate_class::IsRendering(void)
{
	if (ycurrent != -1)
		return true;
	return false;
}

bool KrosseyeDoc::renderstate_class::RenderingLastLine(void)
{
	if (ycurrent == last_row_to_render)
		return true;
	return false;
}
int
 KrosseyeDoc::renderstate_class::GetLine(void)
{
	return (ycurrent);
}
void
 KrosseyeDoc::renderstate_class::StepLine(int inc)
{
	ycurrent += inc;
	if (ycurrent >= last_row_to_render)

	{
		ycurrent = last_row_to_render;
	}
}
int
 KrosseyeDoc::renderstate_class::GetPercentDone(void)
{
	return (100 * (ycurrent - first_row_to_render) /
			(last_row_to_render - first_row_to_render));
}

bool KrosseyeDoc::renderstate_class::TimeToRefreshScreen(void)
{
	if (update_counter++ >= 20)

	{
		update_counter = 0;
		return (true);
	}
	return (false);
}
