/***************************************************************************
                          krosseyeview.h  -  description
                             -------------------
    begin                : Sun Jun 10 19:09:16 CEST 2001
    copyright            : (C) 2001 by Tersevs
    email                : tersevs@home.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KROSSEYEVIEW_H
#define KROSSEYEVIEW_H

// include files for QT
#include <qvariant.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtabwidget.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qscrollview.h>
#include <qpixmap.h>
#include <qevent.h>
#include <mlabel.h>
#include <qpoint.h>

 

// application specific includes
#include "krosseyedoc.h"
#include "krosseyeview_ui.h"

/**
 * This class provides an incomplete base for your application view. 
 */

class KrosseyeView : public krosseyeview_ui
{
  Q_OBJECT
  public:
	  int width, heigth;
	  int mouse_dn_x, mouse_dn_y;
	  int mouse_up_x, mouse_up_y;
	  int mouse_x, mouse_y;

	  KrosseyeView(QWidget *parent=0, KrosseyeDoc* doc=0);
    ~KrosseyeView();

  /** No descriptions */
  void ConfigureDocument(void);


	protected:
//		void mousePressEvent(QMouseEvent *mouseevent);

	KrosseyeDoc *Doc;	
	QScrollView *StereogramScrollView, *DepthmapScrollView, *ColormapScrollView, *PatternScrollView;		
	MLabel *StereogramLabel;
	MLabel  *DepthmapLabel, *ColormapLabel, *PatternLabel;
    QPixmap *StereogramPixmap, *DepthmapPixmap, *ColormapPixmap, *PatternPixmap;
	ButtonState mouse_pressed;

signals: // Signals
  void signalMousePos(int x, int y);

public slots:
	void slotProcessing(int i);

protected slots:
    void slotDocumentChanged();
  
	public slots: // Public slots
		
	/** No descriptions */
	virtual void slotRender();
   	/** No descriptions */
	virtual void slotStop();

	  /** No descriptions */
  	virtual void slotConfig();
	  /** No descriptions */
  	virtual void slotRemerge();
	  /** No descriptions */
  	void slotMousePressEvent(QMouseEvent);
	void slotMouseReleaseEvent(QMouseEvent);
	void slotMouseMoveEvent(QMouseEvent);
	
	virtual void slotRightCol();
	virtual void slotLeftCol();
	
private: // Private methods
};

#endif
